"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var denormalize_1 = require("./denormalize");
var html_parser_1 = require("./html-parser");
var templates_1 = require("./templates");
function getHTMLInfo(html) {
    if (!html) {
        return { externalResources: [], file: null };
    }
    var externalResources = html_parser_1.default(html.content).externalResources;
    return { externalResources: externalResources, file: html };
}
function findMainFile(directory, mainFile, template) {
    if (directory[mainFile]) {
        return mainFile;
    }
    if (directory[templates_1.getMainFile(template)]) {
        return templates_1.getMainFile(template);
    }
    if (directory['src/index.js']) {
        return 'src/index.js';
    }
    if (directory['index.js']) {
        return 'index.js';
    }
    return mainFile || templates_1.getMainFile(template);
}
/**
 * Creates all relevant data for create a sandbox, like dependencies and which
 * files are in a sandbox
 *
 * @export SandboxObject
 * @param {Array<Module>} files
 * @param {Array<Module>} directories
 */
function createSandbox(directory) {
    return __awaiter(this, void 0, void 0, function () {
        var packageJson, packageJsonPackage, template, mainFile, _a, modules, directories;
        return __generator(this, function (_b) {
            packageJson = directory['package.json'];
            if (!packageJson)
                throw new Error('Could not find package.json');
            packageJsonPackage = JSON.parse(packageJson.content);
            template = templates_1.getTemplate(packageJsonPackage, directory);
            mainFile = findMainFile(directory, packageJsonPackage.main, template);
            if (!directory[mainFile]) {
                throw new Error("Cannot find the specified entry point: '" + mainFile + "'. Please specify one in 'package.json#main' or create a file at the specified entry point.");
            }
            _a = denormalize_1.default(directory), modules = _a.modules, directories = _a.directories;
            return [2 /*return*/, {
                    title: packageJsonPackage.title || packageJsonPackage.name,
                    description: packageJsonPackage.description,
                    tags: packageJsonPackage.keywords || [],
                    modules: modules,
                    directories: directories,
                    externalResources: [],
                    template: template,
                    entry: mainFile,
                }];
        });
    });
}
exports.default = createSandbox;
//# sourceMappingURL=index.js.map