"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getMainFile(template) {
    if (template === "vue-cli") {
        return "src/main.js";
    }
    if (template === "angular-cli") {
        return "src/main.ts";
    }
    if (template === "create-react-app-typescript") {
        return "src/index.tsx";
    }
    if (template === "parcel") {
        return "index.html";
    }
    return "src/index.js";
}
exports.getMainFile = getMainFile;
var SANDBOX_CONFIG = "sandbox.config.json";
function getTemplate(packageJSONPackage, modules) {
    if (modules[SANDBOX_CONFIG]) {
        try {
            var config = JSON.parse(modules[SANDBOX_CONFIG].content);
            if (config.template) {
                return config.template;
            }
        }
        catch (e) { }
    }
    if (Object.keys(modules).find(function (m) { return m.endsWith(".vue"); })) {
        return "vue-cli";
    }
    var _a = packageJSONPackage.dependencies, dependencies = _a === void 0 ? {} : _a, _b = packageJSONPackage.devDependencies, devDependencies = _b === void 0 ? {} : _b;
    var totalDependencies = Object.keys(dependencies).concat(Object.keys(devDependencies));
    if (totalDependencies.indexOf("parcel-bundler") > -1) {
        return "parcel";
    }
    if (totalDependencies.indexOf("react-scripts-ts") > -1) {
        return "create-react-app-typescript";
    }
    if (totalDependencies.indexOf("@angular/core") > -1) {
        return "angular-cli";
    }
    if (totalDependencies.indexOf("preact-cli") > -1) {
        return "preact-cli";
    }
    if (totalDependencies.indexOf("svelte") > -1) {
        return "svelte";
    }
    if (totalDependencies.indexOf("vue") > -1) {
        return "vue-cli";
    }
    return "create-react-app";
}
exports.getTemplate = getTemplate;
//# sourceMappingURL=templates.js.map